Ext.define('DSS.editor.ConsumptionStateEditorPart', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 0;
	},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },
    constructGridLvlDetail:function(ZoneID) {
    	if (Ext.data.StoreManager.lookup('consumptionState_Detail') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'consumptionState_Detail',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
    	}
    	Ext.data.StoreManager.lookup('consumptionState_Detail').removeAll();
    	

    	var oArray=dss.staticDataModel.getDevicesForZone(ZoneID,0);
    	
    		
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {			
    		if (oArray[iIndex].present)
        		if ([3,5].indexOf((oArray[iIndex].productID>>10)&0x3f)>-1)
        			if ([8].indexOf((oArray[iIndex].functionID>>12)&0x0f)>-1){
	        			Ext.data.StoreManager.lookup('consumptionState_Detail').add({
							_id:oArray[iIndex].dSUID,
							name:oArray[iIndex].name,
							next:false,
							icon:oArray[iIndex].icon,
							passive:false
						});
        		}
		}
            

        this.grids.lvlDetail = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 188,
            width : 500,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('consumptionState_Detail'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer 
            } ]
        });

        this.grids.lvlDetail.parent = this;

        this.grids.lvlDetail.on('itemclick', function(grid, record) {
             this.getSelectionModel().deselectAll();
             this.getSelectionModel().select(record);
             this.parent.selectDevice(record.get('_id'));
        });
        
        
        var me=this;
        
        this.macPanel.add(this.grids.lvlDetail);
    },
	constructLVL1:function() {
		
		var lvl1Store;
    	if (this.grids.lvl1==null) {
	        var lvl1TempStore = Ext.create('Ext.data.Store', {
	            fields : [ '_id', 'name', 'next', 'icon' ],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            }
	        });
	
	        lvl1Store = Ext.data.StoreManager.lookup('consumptionState_zone');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            lvl1TempStore.add(oNewRecord);
	        });
	        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            hideHeaders:true,
	            height : 188,
	            width : 236,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            selModel : {
	                mode : 'MULTI'
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                text : _('Action'),
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
	        this.grids.lvl1.parent = this;
	
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	        	this.parent.unselectDevice();
                this.parent.macPanel.remove(this.parent.grids.lvlDetail);
                this.getSelectionModel().deselectAll();
                this.getSelectionModel().select(record);
                
                this.parent.constructGridLvlDetail(record.get('ZoneID'));
	            this.parent.macPanel.doLayout();
	        }); 
	        this.macPanel.add(this.grids.lvl1);
    	} else {
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;        	
	        lvl1Store = Ext.data.StoreManager.lookup('consumptionState_zone');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            mThis.grids.lvl1.getStore().add(oNewRecord);
	        });
        	this.macPanel.remove(this.grids.lvlDetail);
    	}
		
	},
	initStores : function () {	
        if (Ext.data.StoreManager.lookup('consumptionState_zone') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'consumptionState_zone',
                fields : [ 'ZoneID', 'name' ,'next'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            
            for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++) {
                var fAdd=false;                
                if (dss.staticDataModel.nameCache[iIndex].ZoneID!=0) {
                	var oArray=dss.staticDataModel.getDevicesForZone(dss.staticDataModel.nameCache[iIndex].ZoneID,0);
                	for (jIndex=0;jIndex<oArray.length;jIndex++) {
                		if (oArray[jIndex].present) {
                			/* technisch möglich ... aber wie immer nicht verfügbar :-(  */
	                		if ([3,5,12].indexOf((oArray[jIndex].productID>>10)&0x3f)>-1) {
	                			fAdd=true;
	                		}                 			
                		}
                	}
                }
                if (fAdd) {
                    Ext.data.StoreManager.lookup('consumptionState_zone').add({ZoneID:dss.staticDataModel.nameCache[iIndex].ZoneID,name:dss.staticDataModel.nameCache[iIndex].name,next:true});
                }
            }
        }
		
	},
	tempSelection:null,
	unselectDevice:function() {
		this.tempSelection=null;
		this.deviceUnready.setVisible(false);
		this.setRetriggeringMinute.setValue(0);
		this.setRetriggeringSeconds.setValue(0);
		this.resetRetriggeringMinute.setValue(0);
		this.resetRetriggeringSeconds.setValue(0);
	},
	selectDevice: function(dSUID) {
		var device=dss.staticDataModel.getDevice(dSUID) 
		if (device.sensorEvents.length==0) {
			this.deviceUnready.setVisible(true);
			this.deviceUnready.setValue(_('<span style="color:#ff0000;">'+_('No consumption event was configured for this device yet. Please configure events in Hardware tab')+'</span>'));
		} else
		if (device.sensorEvents.length==1) {
			this.deviceUnready.setVisible(true);
			if (device.sensorEvents[0].id=='event0') {
				this.deviceUnready.setValue(_('<span style="color:#ff0000;">'+_('Only consumption event for turning on was configured for this device yet. Please configure the off event in Hardware tab')+'</span>'));
			} else {
				this.deviceUnready.setValue(_('<span style="color:#ff0000;">'+_('Only consumption event for turning off was configured for this device yet. Please configure the on event in Hardware tab')+'</span>'));
			}
		} else {
			this.deviceUnready.setVisible(false);
		}
			
		this.setRetriggeringMinute.setValue(0);
		this.setRetriggeringSeconds.setValue(0);
		this.resetRetriggeringMinute.setValue(0);
		this.resetRetriggeringSeconds.setValue(0);
		this.tempSelection=dSUID;
	},
	constructor : function(config) {		
		var me=this;
    	this.initStores();
    	this.grids={};
		
		
		this.macPanel=Ext.create('Ext.panel.Panel', {		
			border : '0',
			title:' ',
            header:false,
			items : [  ],
			height: 190,
			width:738,
			autoScroll : true,
	        layout : {
	            type : 'hbox'
	        },
        	scroll : 'horizontal'        	
		});

		this.deviceUnready=Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:_('<span style="color:#ff0000;">'+_('No consumption event was configured for this device yet. Please configure event in Hardware tab')+'</span>'),
            width:770,
            margin: "7 0 5 5",
            style: {
                fontSize: '11px'
            },
            colspan:4
        });
		
		this.setRetriggeringMinute=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel:_('Set state after a period of'),
            width : 320,
            labelWidth:270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 5",
            autoStripChars:true,
            decimalPrecision:0
        });
		this.setRetriggeringSeconds=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 44,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 0",
            autoStripChars:true,
            decimalPrecision:0
        });
		
		this.resetRetriggeringMinute=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel:_('Reset state after a period of'),
            width : 320,
            labelWidth:270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 5",
            autoStripChars:true,
            decimalPrecision:0
        });
		this.resetRetriggeringSeconds=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 44,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 0",
            autoStripChars:true,
            decimalPrecision:0
        });
		
		this.retriggerPanel=Ext.create('Ext.panel.Panel', {
			border:0,
			items : [this.deviceUnready, 
			         this.setRetriggeringMinute,	         
			         this.setRetriggeringSeconds,
			         {xtype:'displayfield',value:_('mm:ss'), margin: "8 0 0 5", width:50},
			         {xtype:'displayfield',value:_('if no other event was received anymore'), margin: "8 0 0 5", width:370}, 
			         this.resetRetriggeringMinute,	         
			         this.resetRetriggeringSeconds,
			         {xtype:'displayfield',value:_('mm:ss'), margin: "8 0 0 5", width:50},
			         {xtype:'displayfield',value:_('if no other event was received anymore'), margin: "8 0 0 5", width:370}
			         ],
			height: 100,
			width:738,
			layout: {
				type:'table',
    			columns:4
			}
		});
		
		
		Ext.apply(this, {
        	border: 0,
        	margin:"5 0 0 0",
  			items : [this.macPanel,this.retriggerPanel ],
  			height: 300,
  			width:740,
  			layout: {
  				type: 'vbox'
  			}
  		});
  	
        
        
  		this.callParent(arguments);
	},
	reset : function() {
		this.macPanel.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
		this.initStores();
		this.constructLVL1();
		this.unselectDevice();
	},
	isValid : function() {
		if (this.isHidden())
			return true;
		if (this.tempSelection==null) {
			this.macPanel.getEl().child('.x-panel-body').applyStyles('border: solid 1px red');
			return false;
		} else {
			this.macPanel.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
			return true;
		}
	},
	setValue : function(oValue) {
		this.reset();
		var device=dss.staticDataModel.getDevice(oValue.dSID);
		this.constructLVL1();		
		var oRecordZone=this.grids.lvl1.store.find('ZoneID',device.ZoneID,0,false,false,true);
        if (oRecordZone != -1) {
            this.grids.lvl1.getSelectionModel().select(oRecordZone,true);
            this.constructGridLvlDetail(device.ZoneID);
            var oRecordDevice=this.grids.lvlDetail.store.find('_id',oValue.dSID,0,false,false,true);
            if (oRecordDevice!= -1) {
                this.grids.lvlDetail.getSelectionModel().select(oRecordDevice,true);
                this.selectDevice(oValue.dSID);
                this.setRetriggeringSeconds.setValue(oValue.setRetriggeringLag%60);
                this.resetRetriggeringSeconds.setValue(oValue.resetRetriggeringLag%60);
                this.setRetriggeringMinute.setValue(Math.floor(oValue.setRetriggeringLag/60));
                this.resetRetriggeringMinute.setValue(Math.floor(oValue.resetRetriggeringLag/60));
            }
        }
	},
	getValue : function() {
		return {
			dSID:this.tempSelection,
			setRetriggeringLag:this.setRetriggeringSeconds.getValue() + (this.setRetriggeringMinute.getValue()*60),
			resetRetriggeringLag:this.resetRetriggeringSeconds.getValue() + (this.resetRetriggeringMinute.getValue()*60)
		};
	}
});